OPT MODULE
OPT EXPORT

MODULE 'exec/exec'
MODULE 'utility/utility'
MODULE 'hardware/hardware'

CONST NEWLOCKS=1


OBJECT layer
  front:PTR TO layer
  back:PTR TO layer
  cliprect:PTR TO cliprect
  rp:PTR TO rastport
  minx:INT
  miny:INT
  maxx:INT
  maxy:INT
  reserved[4]:ARRAY
  priority:INT  -> This is unsigned
  flags:INT  -> This is unsigned
  superbitmap:PTR TO bitmap
  supercliprect:PTR TO cliprect
  window:LONG
  scroll_x:INT
  scroll_y:INT
  cr:PTR TO cliprect
  cr2:PTR TO cliprect
  crnew:PTR TO cliprect
  supersavercliprects:PTR TO cliprect
-> Um, this had an illegal name
  cliprects_:PTR TO cliprect
  layerinfo:PTR TO layer_info
  lock:ss
  backfill:PTR TO hook
  reserved1:LONG
  clipregion:PTR TO region
  savecliprects:PTR TO region
  reserved2[22]:ARRAY
  damagelist:PTR TO region
ENDOBJECT     /* SIZEOF=160 */

OBJECT cliprect
  next:PTR TO cliprect
  prev:PTR TO cliprect
  lobs:PTR TO layer
  bitmap:PTR TO bitmap
  minx:INT
  miny:INT
  maxx:INT
  maxy:INT
-> Um, these had illegal names
  p1_:LONG
  p2_:LONG
  reserved:LONG
  flags:LONG
ENDOBJECT     /* SIZEOF=40 */

CONST CR_NEEDS_NO_CONCEALED_RASTERS=1,
      CR_NEEDS_NO_LAYERBLIT_DAMAGE=2,
      ISLESSX=1,
      ISLESSY=2,
      ISGRTRX=4,
      ISGRTRY=8,
      LR_FRONT=0,
      LR_BACK=4,
      LR_RASTPORT=12,
      CR_PREV=4,
      CR_LOBS=8

CONST LAYERSIMPLE=1,
      LAYERSMART=2,
      LAYERSUPER=4,
      LAYERUPDATING=16,
      LAYERBACKDROP=$40,
      LAYERREFRESH=$80,
      LAYERIREFRESH=$200,
      LAYERIREFRESH2=$400,
      LAYER_CLIPRECTS_LOST=$100


OBJECT layer_info
  top_layer:PTR TO layer
  check_lp:PTR TO layer
  obs:PTR TO cliprect
  freecliprects:PTR TO cliprect
  privatereserve1:LONG
  privatereserve2:LONG
  lock:ss
  gs_head:mlh
  privatereserve3:INT
  privatereserve4:LONG
  flags:INT  -> This is unsigned
  fatten_count:CHAR
  locklayerscount:CHAR
  privatereserve5:INT
  blankhook:LONG
  layerinfo_extra:LONG
ENDOBJECT     /* SIZEOF=102 */

CONST NEWLAYERINFO_CALLED=1,
      ALERTLAYERSNOMEM=$83010000,
      LAYERS_NOBACKFILL=1,
      LAYERS_BACKFILL=0



CONST PRESERVE_COLORS=1,
      AVOID_FLICKER=2,
      IGNORE_MCOMPAT=4,
      BIDTAG_COERCE=1


CONST BORDERHIT=0,
      TOPHIT=1,
      BOTTOMHIT=2,
      LEFTHIT=4,
      RIGHTHIT=8

CONST COPPER_MOVE=0,
      COPPER_WAIT=1,
      CPRNXTBUF=2,
      CPR_NT_LOF=$8000,
      CPR_NT_SHT=$4000,
      CPR_NT_SYS=$2000

OBJECT copins
  opcode:INT
-> a) next two INTs are unioned with "nxtlist:PTR TO coplist"
-> b) next INT is unioned with "destaddr:INT"
  vwaitpos:INT
-> b) next INT is unioned with "destdata:INT"
  hwaitpos:INT
ENDOBJECT     /* SIZEOF=6 */

#define VWAITPOS vwaitpos
#define DESTADDR vwaitpos
#define HWAITPOS hwaitpos
#define DESTDATA hwaitpos

OBJECT cprlist
  next:PTR TO cprlist
  start:PTR TO INT  -> Target is unsigned
  maxcount:INT
ENDOBJECT     /* SIZEOF=10 */

OBJECT coplist
  next:PTR TO coplist
-> Um, these had illegal names
  coplist_:PTR TO coplist
  viewport_:PTR TO viewport
  copins:PTR TO copins
  copptr:PTR TO copins
  coplstart:PTR TO INT  -> Target is unsigned
  copsstart:PTR TO INT  -> Target is unsigned
  count:INT
  maxcount:INT
  dyoffset:INT
-> Um, if V1_3 only?
->  cop2start:PTR TO INT
->  cop3start:PTR TO INT
->  cop4start:PTR TO INT
->  cop5start:PTR TO INT
  slrepeat:INT  -> This is unsigned
  flags:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=50 */

CONST EXACT_LINE=1,
      HALF_LINE=2

OBJECT ucoplist
  next:PTR TO ucoplist
  firstcoplist:PTR TO coplist
  coplist:PTR TO coplist
ENDOBJECT     /* SIZEOF=12 */

OBJECT copinit
  vsync_hblank[2]:ARRAY OF INT  -> Array is unsigned
  diagstrt[12]:ARRAY OF INT  -> Array is unsigned
  fm0[2]:ARRAY OF INT  -> Array is unsigned
  diwstart[10]:ARRAY OF INT  -> Array is unsigned
  bplcon2[2]:ARRAY OF INT  -> Array is unsigned
  sprfix[16]:ARRAY OF INT  -> Array is unsigned
  sprstrtup[32]:ARRAY OF INT  -> Array is unsigned
  wait14[2]:ARRAY OF INT  -> Array is unsigned
  norm_hblank[2]:ARRAY OF INT  -> Array is unsigned
  jump[2]:ARRAY OF INT  -> Array is unsigned
  wait_forever[6]:ARRAY OF INT  -> Array is unsigned
  sprstop[8]:ARRAY OF INT  -> Array is unsigned
ENDOBJECT     /* SIZEOF=192 */


CONST MODE_640=$8000,
      PLNCNTMSK=7,
      PLNCNTSHFT=12,
      PF2PRI=$40,
      COLORON=$200,
      DBLPF=$400,
      HOLDNMODIFY=$800,
      INTERLACE=4,
      PFA_FINE_SCROLL=15,
      PFB_FINE_SCROLL_SHIFT=4,
      PF_FINE_SCROLL_MASK=15,
      DIW_HORIZ_POS=$7F,
      DIW_VRTCL_POS=$1FF,
      DIW_VRTCL_POS_SHIFT=7,
      DFTCH_MASK=$FF,
      VPOSRLOF=$8000

CONST DTAG_DISP=$80000000,
      DTAG_DIMS=$80001000,
      DTAG_MNTR=$80002000,
      DTAG_NAME=$80003000,
      DTAG_VEC=$80004000

OBJECT qh
  structid:LONG
  displayid:LONG
  skipid:LONG
  length:LONG
ENDOBJECT     /* SIZEOF=16 */

OBJECT displayinfo
  qh:qh
  notavailable:INT  -> This is unsigned
  propertyflags:LONG
  resolution:tpoint
  pixelspeed:INT  -> This is unsigned
  numstdsprites:INT  -> This is unsigned
  paletterange:INT  -> This is unsigned
  spriteresolution:tpoint
  pad[4]:ARRAY
  redbits:CHAR
  greenbits:CHAR
  bluebits:CHAR
  pad2a:CHAR
  pad2b[4]:ARRAY
  reserved[2]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=56 */

CONST DI_AVAIL_NOCHIPS=1,
      DI_AVAIL_NOMONITOR=2,
      DI_AVAIL_NOTWITHGENLOCK=4,
      DIPF_IS_LACE=1,
      DIPF_IS_DUALPF=2,
      DIPF_IS_PF2PRI=4,
      DIPF_IS_HAM=8,
      DIPF_IS_ECS=16,
      DIPF_IS_AA=$10000,
      DIPF_IS_PAL=$20,
      DIPF_IS_SPRITES=$40,
      DIPF_IS_GENLOCK=$80,
      DIPF_IS_WB=$100,
      DIPF_IS_DRAGGABLE=$200,
      DIPF_IS_PANELLED=$400,
      DIPF_IS_BEAMSYNC=$800,
      DIPF_IS_EXTRAHALFBRITE=$1000,
      DIPF_IS_SPRITES_ATT=$2000,
      DIPF_IS_SPRITES_CHNG_RES=$4000,
      DIPF_IS_SPRITES_BORDER=$8000,
      DIPF_IS_SCANDBL=$20000,
      DIPF_IS_SPRITES_CHNG_BASE=$40000,
      DIPF_IS_SPRITES_CHNG_PRI=$80000,
      DIPF_IS_DBUFFER=$100000,
      DIPF_IS_PROGBEAM=$200000,
      DIPF_IS_FOREIGN=$80000000

OBJECT dimensioninfo
  qh:qh
  maxdepth:INT  -> This is unsigned
  minrasterwidth:INT  -> This is unsigned
  minrasterheight:INT  -> This is unsigned
  maxrasterwidth:INT  -> This is unsigned
  maxrasterheight:INT  -> This is unsigned
  nominal:rectangle
  maxoscan:rectangle
  videooscan:rectangle
  txtoscan:rectangle
  stdoscan:rectangle
  pad[14]:ARRAY
  reserved[2]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=88 */

OBJECT monitorinfo
  qh:qh
  mspc:PTR TO monitorspec
  viewposition:tpoint
  viewresolution:tpoint
  viewpositionrange:rectangle
  totalrows:INT  -> This is unsigned
  totalcolorclocks:INT  -> This is unsigned
  minrow:INT  -> This is unsigned
  compatibility:INT
  pad[32]:ARRAY
  mousetick:tpoint
  defaultviewposition:tpoint
  preferredmodeid:LONG
  reserved[2]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=96 */

CONST MCOMPAT_MIXED=0,
      MCOMPAT_SELF=1,
      MCOMPAT_NOBODY=-1,
      DISPLAYNAMELEN=$20

OBJECT nameinfo
  qh:qh
  name[32]:ARRAY
  reserved[2]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=56 */

OBJECT vecinfo
  qh:qh
  vec:LONG
  data:LONG
  type:INT  -> This is unsigned
  pad[3]:ARRAY OF INT  -> Array is unsigned
  reserved[2]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=40 */


CONST SUSERFLAGS=$FF,
      VSF_VSPRITE=1,
      VSF_SAVEBACK=2,
      VSF_OVERLAY=4,
      VSF_MUSTDRAW=8,
      VSF_BACKSAVED=$100,
      VSF_BOBUPDATE=$200,
      VSF_GELGONE=$400,
      VSF_VSOVERFLOW=$800,
      BUSERFLAGS=$FF,
      BF_SAVEBOB=1,
      BF_BOBISCOMP=2,
      BF_BWAITING=$100,
      BF_BDRAWN=$200,
      BF_BOBSAWAY=$400,
      BF_BOBNIX=$800,
      BF_SAVEPRESERVE=$1000,
      BF_OUTSTEP=$2000,
      ANFRACSIZE=6,
      ANIMHALF=$20,
      RINGTRIGGER=1

OBJECT vs
  nextvsprite:PTR TO vs
  prevvsprite:PTR TO vs
  drawpath:PTR TO vs
  clearpath:PTR TO vs
  oldy:INT
  oldx:INT
  vsflags:INT
  y:INT
  x:INT
  height:INT
  width:INT
  depth:INT
  memask:INT
  hitmask:INT
  imagedata:PTR TO INT
  borderline:PTR TO INT
  collmask:PTR TO INT
  sprcolors:PTR TO INT
  vsbob:PTR TO bob
  planepick:CHAR  -> This is signed
  planeonoff:CHAR  -> This is signed
  vuserext:LONG
ENDOBJECT     /* SIZEOF=58 */

OBJECT bob
  bobflags:INT
  savebuffer:PTR TO INT
  imageshadow:PTR TO INT
  before:PTR TO bob
  after:PTR TO bob
  bobvsprite:PTR TO vs
  bobcomp:PTR TO ac
  dbuffer:PTR TO dbp
  buserext:LONG
ENDOBJECT     /* SIZEOF=30 */

OBJECT ac
  compflags:INT
  timer:INT
  timeset:INT
  nextcomp:PTR TO ac
  prevcomp:PTR TO ac
  nextseq:PTR TO ac
  prevseq:PTR TO ac
  animcroutine:LONG
  ytrans:INT
  xtrans:INT
  headob:PTR TO ao
  animbob:PTR TO bob
ENDOBJECT     /* SIZEOF=38 */

OBJECT ao
  nextob:PTR TO ao
  prevob:PTR TO ao
  clock:LONG
  anoldy:INT
  anoldx:INT
  any:INT
  anx:INT
  yvel:INT
  xvel:INT
  yaccel:INT
  xaccel:INT
  ringytrans:INT
  ringxtrans:INT
  animoroutine:LONG
  headcomp:PTR TO ac
  auserext:LONG
ENDOBJECT     /* SIZEOF=40 */

OBJECT dbp
  bufy:INT
  bufx:INT
  bufpath:PTR TO vs
  bufbuffer:PTR TO INT
-> Um, 'bufplanes' not in .h file
  bufplanes:PTR TO LONG
ENDOBJECT     /* SIZEOF=16 */

#define InitAnimate(animKey) PutLong(animKey,NIL)
#define RemBob(b)            PutInt(b, Int(b) OR BF_BOBSAWAY)

CONST B2NORM=0,
      B2SWAP=1,
      B2BOBBER=2

-> Um, this was in 'graphics/view'
OBJECT colltable
  collptrs[16]:ARRAY OF LONG
ENDOBJECT

#define RASSIZE(w,h) (Mul((h),Shr((w)+15,3) AND $FFFE))

CONST BITSET=$8000,
      BITCLR=0,
      AGNUS=1,
      DENISE=1

OBJECT bitmap
  bytesperrow:INT  -> This is unsigned
  rows:INT  -> This is unsigned
  flags:CHAR
  depth:CHAR
  pad:INT
  planes[8]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=40 */

OBJECT rectangle
  minx:INT
  miny:INT
  maxx:INT
  maxy:INT
ENDOBJECT     /* SIZEOF=8 */

OBJECT rect32
  minx:LONG
  miny:LONG
  maxx:LONG
  maxy:LONG
ENDOBJECT     /* SIZEOF=16 */

OBJECT tpoint
  x:INT
  y:INT
ENDOBJECT     /* SIZEOF=4 */

CONST BMB_CLEAR=0,
      BMB_DISPLAYABLE=1,
      BMB_INTERLEAVED=2,
      BMB_STANDARD=3,
      BMB_MINPLANES=4,
      BMF_CLEAR=1,
      BMF_DISPLAYABLE=2,
      BMF_INTERLEAVED=4,
      BMF_STANDARD=8,
      BMF_MINPLANES=16,
      BMA_HEIGHT=0,
      BMA_DEPTH=4,
      BMA_WIDTH=8,
      BMA_FLAGS=12


OBJECT gfxbase
-> Um, this was missing
  lib:lib
  actiview:PTR TO view
  copinit:PTR TO copinit
  cia:PTR TO LONG
  blitter:PTR TO LONG
  loflist:PTR TO INT  -> Target is unsigned
  shflist:PTR TO INT  -> Target is unsigned
  blthd:PTR TO bltnode
  blttl:PTR TO bltnode
  bsblthd:PTR TO bltnode
  bsblttl:PTR TO bltnode
  vbsrv:is
  timsrv:is
  bltsrv:is
  textfonts:lh
  defaultfont:PTR TO textfont
  modes:INT  -> This is unsigned
  vblank:CHAR  -> This is signed
  debug:CHAR  -> This is signed
  beamsync:INT
  system_bplcon0:INT
  spritereserved:CHAR
  bytereserved:CHAR
  flags:INT  -> This is unsigned
  blitlock:INT
  blitnest:INT
  blitwaitq:lh
  blitowner:PTR TO tc
  tof_waitq:lh
  displayflags:INT  -> This is unsigned
-> This is really PTR TO PTR TO simplesprite
  simplesprites:PTR TO LONG
  maxdisplayrow:INT  -> This is unsigned
  maxdisplaycolumn:INT  -> This is unsigned
  normaldisplayrows:INT  -> This is unsigned
  normaldisplaycolumns:INT  -> This is unsigned
  normaldpmx:INT  -> This is unsigned
  normaldpmy:INT  -> This is unsigned
  lastchancememory:PTR TO ss
  lcmptr:PTR TO INT  -> Target is unsigned
  microsperline:INT  -> This is unsigned
  mindisplaycolumn:INT  -> This is unsigned
  chiprevbits0:CHAR
  memtype:CHAR
  crb_reserved[4]:ARRAY
  monitor_id:INT  -> This is unsigned
  hedley[8]:ARRAY OF LONG
  hedley_sprites[8]:ARRAY OF LONG
  hedley_sprites1[8]:ARRAY OF LONG
  hedley_count:INT
  hedley_flags:INT  -> This is unsigned
  hedley_tmp:INT
  hash_table:PTR TO LONG
  current_tot_rows:INT  -> This is unsigned
  current_tot_cclks:INT  -> This is unsigned
  hedley_hint:CHAR
  hedley_hint2:CHAR
  nreserved[4]:ARRAY OF LONG
  a2024_sync_raster:PTR TO LONG
  control_delta_pal:INT  -> This is unsigned
  control_delta_ntsc:INT  -> This is unsigned
  current_monitor:PTR TO monitorspec
  monitorlist:lh
  default_monitor:PTR TO monitorspec
  monitorlistsemaphore:PTR TO ss
  displayinfodatabase:LONG
  topline:INT  -> This is unsigned
  activiewcprsemaphore:PTR TO ss
  utilbase:PTR TO LONG
  execbase:PTR TO LONG
  bwshifts:PTR TO CHAR
  strtfetchmasks:PTR TO INT  -> Target is unsigned
  stopfetchmasks:PTR TO INT  -> Target is unsigned
  overrun:PTR TO INT  -> Target is unsigned
  realstops:PTR TO INT
  spritewidth:INT  -> This is unsigned
  spritefmode:INT  -> This is unsigned
  softsprites:CHAR  -> This is signed
  arraywidth:CHAR  -> This is signed
  defaultspritewidth:INT  -> This is unsigned
  sprmovedisable:CHAR  -> This is signed
  wantchips:CHAR
  boardmemtype:CHAR
  bugs:CHAR
  layersbase:PTR TO LONG
  colormask:LONG
  ivector:LONG
  idata:LONG
  specialcounter:LONG
  dblist:LONG
  monitorflags:INT  -> This is unsigned
  scandoubledsprites:CHAR
  bp3bits:CHAR
  monitorvblank:analogsignalinterval
  natural_monitor:PTR TO monitorspec
  progdata:LONG
  extsprites:CHAR
  pad3:CHAR
  gfxflags:INT  -> This is unsigned
  vbcounter:LONG
  hashtablesemaphore:PTR TO ss
  hwemul[9]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=497 */

#define chunkytoplanarptr hwemul[0]

CONST OWNBLITTERN=0,
      QBOWNERN=1,
      BLITMSG_FAULTN=2,
      BLITMSG_FAULT=4,
      QBOWNER=2,
      GBFLAGSF_TIMER=$40,
      GBFLAGSF_LASTBLIT=$80,
      GFXB_BIG_BLITS=0,
      GFXB_HR_AGNUS=0,
      GFXB_HR_DENISE=1,
      GFXB_AA_ALICE=2,
      GFXB_AA_LISA=3,
      GFXB_AA_MLISA=4,
      GFXF_BIG_BLITS=1,
      GFXF_HR_AGNUS=1,
      GFXF_HR_DENISE=2,
      GFXF_AA_ALICE=4,
      GFXF_AA_LISA=8,
      GFXF_AA_MLISA=16,
      SETCHIPREV_A=1,
      SETCHIPREV_ECS=3,
      SETCHIPREV_AA=15,
      SETCHIPREV_BEST=-1,
      BUS_16=0,
      NML_CAS=0,
      BUS_32=1,
      DBL_CAS=2,
      BANDWIDTH_1X=0,
      BANDWIDTH_2XNML=1,
      BANDWIDTH_2XDBL=2,
      BANDWIDTH_4X=3,
      NEW_DATABASE=1,
      NTSCN=0,
      NTSC=1,
      GENLOCN=1,
      GENLOC=2,
      PALN=2,
      PAL=4,
      TODA_SAFEN=3,
      TODA_SAFE=8,
      REALLY_PALN=4,
      REALLY_PAL=16,
      LPEN_SWAP_FRAMES=32

#define GRAPHICSNAME 'graphics.library'

-> These need 'graphics/gfx', 'hardware/custom', 'hardware/dmabits'
#define ON_DISPLAY      PutInt(CUSTOMADDR+DMACON,BITSET OR DMAF_RASTER)
#define OFF_DISPLAY     PutInt(CUSTOMADDR+DMACON,BITCLR OR DMAF_RASTER)
#define ON_SPRITE       PutInt(CUSTOMADDR+DMACON,BITSET OR DMAF_SPRITE)
#define OFF_SPRITE      PutInt(CUSTOMADDR+DMACON,BITCLR OR DMAF_SPRITE)

-> Same, but 'hardware/intbits' instead of 'hardware/dmabits'
#define ON_VBLANK       PutInt(CUSTOMADDR+INTENA,BITSET OR INTF_VERTB)
#define OFF_VBLANK      PutInt(CUSTOMADDR+INTENA,BITCLR OR INTF_VERTB)

#define SetDrPt(w,p)   (PutInt((w)+RP_LINEPTRN,(p)) BUT \
                       PutInt((w)+RP_FLAGS,Int((w)+RP_FLAGS) OR FRST_DOT) BUT \
                       PutChar((w)+RP_LINPATCNT,15))
#define SetAfPt(w,p,n) (PutLong((w)+RP_AREAPTRN,(p)) BUT \
                       PutChar((w)+RP_AREAPTSZ,(n)))

#define SetOPen(w,c)   (PutChar((w)+RP_AOLPEN,(c)) BUT \
                       PutInt((w)+RP_FLAGS,Int((w)+RP_FLAGS) OR RPF_AREAOUTLINE))
#define SetWrMsk(w,m)  PutChar((w)+RP_MASK,(m))

#define SafeSetOutlinePen(w,c) (IF KickVersion(39) THEN SetOutlinePen((w),(c)) \
                               ELSE SetOPen(w,c))
#define SafeSetWriteMask(w,m)  (IF KickVersion(39) THEN SetWriteMask((w),(m)) \
                               ELSE SetWrMsk(w,m))

#define GetOutlinePen(rp) GetOPen((rp))

#define BNDRYOFF(w)  PutInt((w)+RP_FLAGS,Int((w)+RP_FLAGS) AND Not(RPF_AREAOUTLINE))

#define CINIT(c,n)     UcopperListInit((c),(n))
#define CMOVE(c,a,b)   (Cmove((c),{a},(b)) BUT Cbump((c)))
-> CMOVE is a little hard to use due to {a}.  CMOVEA() is the same except it
-> expects the address, so it may be easier to use...
#define CMOVEA(c,d,b)  (Cmove((c),(d),(b)) BUT Cbump((c)))
#define CWAIT(c,a,b)   (Cwait((c),(a),(b)) BUT Cbump((c)))
#define CEND(c)        CWAIT((c),10000,255)

#define DrawCircle(rp,cx,cy,r)  DrawEllipse((rp),(cx),(cy),(r),(r))
#define AreaCircle(rp,cx,cy,r)  AreaEllipse((rp),(cx),(cy),(r),(r))

OBJECT xln
  succ:PTR TO ln
  pred:PTR TO ln
  type:CHAR
  pri:CHAR  -> This is signed
  name:PTR TO CHAR
  subsystem:CHAR
  subtype:CHAR
  library:LONG
  init:LONG
ENDOBJECT     /* SIZEOF=24 */

CONST SS_GRAPHICS=2,
      VIEW_EXTRA_TYPE=1,
      VIEWPORT_EXTRA_TYPE=2,
      SPECIAL_MONITOR_TYPE=3,
      MONITOR_SPEC_TYPE=4


OBJECT isrvstr
  ln:ln
  iptr:PTR TO isrvstr
  code:LONG
  ccode:LONG
  carg:LONG
ENDOBJECT

CONST INVALID_ID=-1,
      MONITOR_ID_MASK=$FFFF1000,
      DEFAULT_MONITOR_ID=0,
      NTSC_MONITOR_ID=$11000,
      PAL_MONITOR_ID=$21000,
      LORES_KEY=0,
      HIRES_KEY=$8000,
      SUPER_KEY=$8020,
      HAM_KEY=$800,
      LORESLACE_KEY=4,
      HIRESLACE_KEY=$8004,
      SUPERLACE_KEY=$8024,
      HAMLACE_KEY=$804,
      LORESDPF_KEY=$400,
      HIRESDPF_KEY=$8400,
      SUPERDPF_KEY=$8420,
      LORESLACEDPF_KEY=$404,
      HIRESLACEDPF_KEY=$8404,
      SUPERLACEDPF_KEY=$8424,
      LORESDPF2_KEY=$440,
      HIRESDPF2_KEY=$8440,
      SUPERDPF2_KEY=$8460,
      LORESLACEDPF2_KEY=$444,
      HIRESLACEDPF2_KEY=$8444,
      SUPERLACEDPF2_KEY=$8464,
      EXTRAHALFBRITE_KEY=$80,
      EXTRAHALFBRITELACE_KEY=$84,
      HIRESHAM_KEY=$8800,
      SUPERHAM_KEY=$8820,
      HIRESEHB_KEY=$8080,
      SUPEREHB_KEY=$80A0,
      HIRESHAMLACE_KEY=$8804,
      SUPERHAMLACE_KEY=$8824,
      HIRESEHBLACE_KEY=$8084,
      SUPEREHBLACE_KEY=$80A4,
      LORESSDBL_KEY=8,
      LORESHAMSDBL_KEY=$808,
      LORESEHBSDBL_KEY=$88,
      HIRESHAMSDBL_KEY=$8808,
      VGA_MONITOR_ID=$31000,
      VGAEXTRALORES_KEY=$31004,
      VGALORES_KEY=$39004,
      VGAPRODUCT_KEY=$39024,
      VGAHAM_KEY=$31804,
      VGAEXTRALORESLACE_KEY=$31005,
      VGALORESLACE_KEY=$39005,
      VGAPRODUCTLACE_KEY=$39025,
      VGAHAMLACE_KEY=$31805,
      VGAEXTRALORESDPF_KEY=$31404,
      VGALORESDPF_KEY=$39404,
      VGAPRODUCTDPF_KEY=$39424,
      VGAEXTRALORESLACEDPF_KEY=$31405,
      VGALORESLACEDPF_KEY=$39405,
      VGAPRODUCTLACEDPF_KEY=$39425,
      VGAEXTRALORESDPF2_KEY=$31444,
      VGALORESDPF2_KEY=$39444,
      VGAPRODUCTDPF2_KEY=$39464,
      VGAEXTRALORESLACEDPF2_KEY=$31445,
      VGALORESLACEDPF2_KEY=$39445,
      VGAPRODUCTLACEDPF2_KEY=$39465,
      VGAEXTRAHALFBRITE_KEY=$31084,
      VGAEXTRAHALFBRITELACE_KEY=$31085,
      VGAPRODUCTHAM_KEY=$39824,
      VGALORESHAM_KEY=$39804,
      VGAEXTRALORESHAM_KEY=$31804,
      VGAPRODUCTHAMLACE_KEY=$39825,
      VGALORESHAMLACE_KEY=$39805,
      VGAEXTRALORESHAMLACE_KEY=$31805,
      VGAEXTRALORESEHB_KEY=$31084,
      VGAEXTRALORESEHBLACE_KEY=$31085,
      VGALORESEHB_KEY=$39084,
      VGALORESEHBLACE_KEY=$39085,
      VGAEHB_KEY=$390A4,
      VGAEHBLACE_KEY=$390A5,
      VGAEXTRALORESDBL_KEY=$31000,
      VGALORESDBL_KEY=$39000,
      VGAPRODUCTDBL_KEY=$39020,
      VGAEXTRALORESHAMDBL_KEY=$31800,
      VGALORESHAMDBL_KEY=$39800,
      VGAPRODUCTHAMDBL_KEY=$39820,
      VGAEXTRALORESEHBDBL_KEY=$31080,
      VGALORESEHBDBL_KEY=$39080,
      VGAPRODUCTEHBDBL_KEY=$390A0,
      A2024_MONITOR_ID=$41000,
      A2024TENHERTZ_KEY=$41000,
      A2024FIFTEENHERTZ_KEY=$49000,
      PROTO_MONITOR_ID=$51000,
      EURO72_MONITOR_ID=$61000,
      EURO72EXTRALORES_KEY=$61004,
      EURO72LORES_KEY=$69004,
      EURO72PRODUCT_KEY=$69024,
      EURO72HAM_KEY=$61804,
      EURO72EXTRALORESLACE_KEY=$61005,
      EURO72LORESLACE_KEY=$69005,
      EURO72PRODUCTLACE_KEY=$69025,
      EURO72HAMLACE_KEY=$61805,
      EURO72EXTRALORESDPF_KEY=$61404,
      EURO72LORESDPF_KEY=$69404,
      EURO72PRODUCTDPF_KEY=$69424,
      EURO72EXTRALORESLACEDPF_KEY=$61405,
      EURO72LORESLACEDPF_KEY=$69405,
      EURO72PRODUCTLACEDPF_KEY=$69425,
      EURO72EXTRALORESDPF2_KEY=$61444,
      EURO72LORESDPF2_KEY=$69444,
      EURO72PRODUCTDPF2_KEY=$69464,
      EURO72EXTRALORESLACEDPF2_KEY=$61445,
      EURO72LORESLACEDPF2_KEY=$69445,
      EURO72PRODUCTLACEDPF2_KEY=$69465,
      EURO72EXTRAHALFBRITE_KEY=$61084,
      EURO72EXTRAHALFBRITELACE_KEY=$61085,
      EURO72PRODUCTHAM_KEY=$69824,
      EURO72PRODUCTHAMLACE_KEY=$69825,
      EURO72LORESHAM_KEY=$69804,
      EURO72LORESHAMLACE_KEY=$69805,
      EURO72EXTRALORESHAM_KEY=$61804,
      EURO72EXTRALORESHAMLACE_KEY=$61805,
      EURO72EXTRALORESEHB_KEY=$61084,
      EURO72EXTRALORESEHBLACE_KEY=$61085,
      EURO72LORESEHB_KEY=$69084,
      EURO72LORESEHBLACE_KEY=$69085,
      EURO72EHB_KEY=$690A4,
      EURO72EHBLACE_KEY=$690A5,
      EURO72EXTRALORESDBL_KEY=$61000,
      EURO72LORESDBL_KEY=$69000,
      EURO72PRODUCTDBL_KEY=$69020,
      EURO72EXTRALORESHAMDBL_KEY=$61800,
      EURO72LORESHAMDBL_KEY=$69800,
      EURO72PRODUCTHAMDBL_KEY=$69820,
      EURO72EXTRALORESEHBDBL_KEY=$61080,
      EURO72LORESEHBDBL_KEY=$69080,
      EURO72PRODUCTEHBDBL_KEY=$690A0,
      EURO36_MONITOR_ID=$71000,
      SUPER72_MONITOR_ID=$81000,
      SUPER72LORESDBL_KEY=$81008,
      SUPER72HIRESDBL_KEY=$89008,
      SUPER72SUPERDBL_KEY=$89028,
      SUPER72LORESHAMDBL_KEY=$81808,
      SUPER72HIRESHAMDBL_KEY=$89808,
      SUPER72SUPERHAMDBL_KEY=$89828,
      SUPER72LORESEHBDBL_KEY=$81088,
      SUPER72HIRESEHBDBL_KEY=$89088,
      SUPER72SUPEREHBDBL_KEY=$890A8,
      DBLNTSC_MONITOR_ID=$91000,
      DBLNTSCLORES_KEY=$91000,
      DBLNTSCLORESFF_KEY=$91004,
      DBLNTSCLORESHAM_KEY=$91800,
      DBLNTSCLORESHAMFF_KEY=$91804,
      DBLNTSCLORESEHB_KEY=$91080,
      DBLNTSCLORESEHBFF_KEY=$91084,
      DBLNTSCLORESLACE_KEY=$91005,
      DBLNTSCLORESHAMLACE_KEY=$91805,
      DBLNTSCLORESEHBLACE_KEY=$91085,
      DBLNTSCLORESDPF_KEY=$91400,
      DBLNTSCLORESDPFFF_KEY=$91404,
      DBLNTSCLORESDPFLACE_KEY=$91405,
      DBLNTSCLORESDPF2_KEY=$91440,
      DBLNTSCLORESDPF2FF_KEY=$91444,
      DBLNTSCLORESDPF2LACE_KEY=$91445,
      DBLNTSCHIRES_KEY=$99000,
      DBLNTSCHIRESFF_KEY=$99004,
      DBLNTSCHIRESHAM_KEY=$99800,
      DBLNTSCHIRESHAMFF_KEY=$99804,
      DBLNTSCHIRESLACE_KEY=$99005,
      DBLNTSCHIRESHAMLACE_KEY=$99805,
      DBLNTSCHIRESEHB_KEY=$99080,
      DBLNTSCHIRESEHBFF_KEY=$99084,
      DBLNTSCHIRESEHBLACE_KEY=$99085,
      DBLNTSCHIRESDPF_KEY=$99400,
      DBLNTSCHIRESDPFFF_KEY=$99404,
      DBLNTSCHIRESDPFLACE_KEY=$99405,
      DBLNTSCHIRESDPF2_KEY=$99440,
      DBLNTSCHIRESDPF2FF_KEY=$99444,
      DBLNTSCHIRESDPF2LACE_KEY=$99445,
      DBLNTSCEXTRALORES_KEY=$91200,
      DBLNTSCEXTRALORESHAM_KEY=$91A00,
      DBLNTSCEXTRALORESEHB_KEY=$91280,
      DBLNTSCEXTRALORESDPF_KEY=$91600,
      DBLNTSCEXTRALORESDPF2_KEY=$91640,
      DBLNTSCEXTRALORESFF_KEY=$91204,
      DBLNTSCEXTRALORESHAMFF_KEY=$91A04,
      DBLNTSCEXTRALORESEHBFF_KEY=$91284,
      DBLNTSCEXTRALORESDPFFF_KEY=$91604,
      DBLNTSCEXTRALORESDPF2FF_KEY=$91644,
      DBLNTSCEXTRALORESLACE_KEY=$91205,
      DBLNTSCEXTRALORESHAMLACE_KEY=$91A05,
      DBLNTSCEXTRALORESEHBLACE_KEY=$91285,
      DBLNTSCEXTRALORESDPFLACE_KEY=$91605,
      DBLNTSCEXTRALORESDPF2LACE_KEY=$91645,
      DBLPAL_MONITOR_ID=$A1000,
      DBLPALLORES_KEY=$A1000,
      DBLPALLORESFF_KEY=$A1004,
      DBLPALLORESHAM_KEY=$A1800,
      DBLPALLORESHAMFF_KEY=$A1804,
      DBLPALLORESEHB_KEY=$A1080,
      DBLPALLORESEHBFF_KEY=$A1084,
      DBLPALLORESLACE_KEY=$A1005,
      DBLPALLORESHAMLACE_KEY=$A1805,
      DBLPALLORESEHBLACE_KEY=$A1085,
      DBLPALLORESDPF_KEY=$A1400,
      DBLPALLORESDPFFF_KEY=$A1404,
      DBLPALLORESDPFLACE_KEY=$A1405,
      DBLPALLORESDPF2_KEY=$A1440,
      DBLPALLORESDPF2FF_KEY=$A1444,
      DBLPALLORESDPF2LACE_KEY=$A1445,
      DBLPALHIRES_KEY=$A9000,
      DBLPALHIRESFF_KEY=$A9004,
      DBLPALHIRESHAM_KEY=$A9800,
      DBLPALHIRESHAMFF_KEY=$A9804,
      DBLPALHIRESLACE_KEY=$A9005,
      DBLPALHIRESHAMLACE_KEY=$A9805,
      DBLPALHIRESEHB_KEY=$A9080,
      DBLPALHIRESEHBFF_KEY=$A9084,
      DBLPALHIRESEHBLACE_KEY=$A9085,
      DBLPALHIRESDPF_KEY=$A9400,
      DBLPALHIRESDPFFF_KEY=$A9404,
      DBLPALHIRESDPFLACE_KEY=$A9405,
      DBLPALHIRESDPF2_KEY=$A9440,
      DBLPALHIRESDPF2FF_KEY=$A9444,
      DBLPALHIRESDPF2LACE_KEY=$A9445,
      DBLPALEXTRALORES_KEY=$A1200,
      DBLPALEXTRALORESHAM_KEY=$A1A00,
      DBLPALEXTRALORESEHB_KEY=$A1280,
      DBLPALEXTRALORESDPF_KEY=$A1600,
      DBLPALEXTRALORESDPF2_KEY=$A1640,
      DBLPALEXTRALORESFF_KEY=$A1204,
      DBLPALEXTRALORESHAMFF_KEY=$A1A04,
      DBLPALEXTRALORESEHBFF_KEY=$A1284,
      DBLPALEXTRALORESDPFFF_KEY=$A1604,
      DBLPALEXTRALORESDPF2FF_KEY=$A1644,
      DBLPALEXTRALORESLACE_KEY=$A1205,
      DBLPALEXTRALORESHAMLACE_KEY=$A1A05,
      DBLPALEXTRALORESEHBLACE_KEY=$A1285,
      DBLPALEXTRALORESDPFLACE_KEY=$A1605,
      DBLPALEXTRALORESDPF2LACE_KEY=$A1645,
      MUST_FLAGS=$100E,
      SPECIAL_FLAGS=$100E,
      BIDTAG_DIPFMUSTHAVE=$80000001,
      BIDTAG_DIPFMUSTNOTHAVE=$80000002,
      BIDTAG_VIEWPORT=$80000003,
      BIDTAG_NOMINALWIDTH=$80000004,
      BIDTAG_NOMINALHEIGHT=$80000005,
      BIDTAG_DESIREDWIDTH=$80000006,
      BIDTAG_DESIREDHEIGHT=$80000007,
      BIDTAG_DEPTH=$80000008,
      BIDTAG_MONITORID=$80000009,
      BIDTAG_SOURCEID=$8000000A,
      BIDTAG_REDBITS=$8000000B,
      BIDTAG_BLUEBITS=$8000000C,
      BIDTAG_GREENBITS=$8000000D,
      BIDTAG_GFXPRIVATE=$8000000E

OBJECT analogsignalinterval
  start:INT  -> This is unsigned
  stop:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=4 */

OBJECT specialmonitor
  xln:xln
  flags:INT  -> This is unsigned
  do_monitor:LONG
  reserved1:LONG
  reserved2:LONG
  reserved3:LONG
  hblank:analogsignalinterval
  vblank:analogsignalinterval
  hsync:analogsignalinterval
  vsync:analogsignalinterval
ENDOBJECT     /* SIZEOF=58 */

OBJECT monitorspec
  xln:xln
  flags:INT  -> This is unsigned
  ratioh:LONG
  ratiov:LONG
  total_rows:INT  -> This is unsigned
  total_colorclocks:INT  -> This is unsigned
  denisemaxdisplaycolumn:INT  -> This is unsigned
  beamcon0:INT  -> This is unsigned
  min_row:INT  -> This is unsigned
  special:PTR TO specialmonitor
  opencount:INT  -> This is unsigned
  transform:LONG
  translate:LONG
  scale:LONG
  xoffset:INT  -> This is unsigned
  yoffset:INT  -> This is unsigned
  legalview:rectangle
  maxoscan:LONG
  videoscan:LONG
  denisemindisplaycolumn:INT  -> This is unsigned
  displaycompatible:LONG
  displayinfodatabase:lh
  didbsemaphore:ss
  mrgcop:LONG
  loadview:LONG
  killview:LONG
ENDOBJECT     /* SIZEOF=160 */

CONST MSB_REQUEST_NTSC=0,
      MSB_REQUEST_PAL=1,
      MSB_REQUEST_SPECIAL=2,
      MSB_REQUEST_A2024=3,
      MSB_DOUBLE_SPRITES=4,
      MSF_REQUEST_NTSC=1,
      MSF_REQUEST_PAL=2,
      MSF_REQUEST_SPECIAL=4,
      MSF_REQUEST_A2024=8,
      MSF_DOUBLE_SPRITES=16,
      STANDARD_VIEW_X=$81,
      STANDARD_VIEW_Y=$2C,
      TO_MONITOR=0,
      FROM_MONITOR=1,
      STANDARD_XOFFSET=9,
      STANDARD_YOFFSET=0,
      REQUEST_NTSC=1,
      REQUEST_PAL=2,
      REQUEST_SPECIAL=4,
      REQUEST_A2024=8,
      STANDARD_MONITOR_MASK=3,
      STANDARD_NTSC_ROWS=262,
      STANDARD_PAL_ROWS=312,
      STANDARD_COLORCLOCKS=226,
      STANDARD_DENISE_MAX=455,
      STANDARD_DENISE_MIN=93,
      STANDARD_NTSC_BEAMCON=0,
      STANDARD_PAL_BEAMCON=$20,
      SPECIAL_BEAMCON=$1b8a,
      MIN_NTSC_ROW=21,
      MIN_PAL_ROW=29,
      STANDARD_VIEW_X=$81,
      STANDARD_VIEW_Y=$2C,
      STANDARD_HBSTRT=$6,
      STANDARD_HSSTRT=$B,
      STANDARD_HSSTOP=$1C,
      STANDARD_HBSTOP=$2C,
      STANDARD_VBSTRT=$122,
      STANDARD_VSSTRT=$2A6,
      STANDARD_VSSTOP=$3AA,
      STANDARD_VBSTOP=$1066,
      VGA_COLORCLOCKS=113,
      VGA_TOTAL_ROWS=131,
      VGA_DENISE_MIN=59,
      MIN_VGA_ROW=29,
      VGA_HBSTRT=$8,
      VGA_HSSTRT=$0E,
      VGA_HSSTOP=$1C,
      VGA_HBSTOP=$1E,
      VGA_VBSTRT=0,
      VGA_VSSTRT=$153,
      VGA_VSSTOP=$235,
      VGA_VBSTOP=$CCD,
      BROADCAST_HBSTRT=$1,
      BROADCAST_HSSTRT=$6,
      BROADCAST_HSSTOP=$17,
      BROADCAST_HBSTOP=$27,
      BROADCAST_VBSTRT=0,
      BROADCAST_VSSTRT=$2A6,
      BROADCAST_VSSTOP=$054C,
      BROADCAST_VBSTOP=$1C40,
      BROADCAST_BEAMCON=$808,
      RATIO_FIXEDPART=4,
      RATIO_UNITY=16

#define DEFAULT_MONITOR_NAME 'default.monitor'
#define NTSC_MONITOR_NAME 'ntsc.monitor'
#define PAL_MONITOR_NAME 'pal.monitor'
#define VGA_MONITOR_NAME 'vga.monitor'

OBJECT tmpras
  rasptr:PTR TO CHAR
  size:LONG
ENDOBJECT     /* SIZEOF=8 */

OBJECT gelsinfo
  sprrsrvd:CHAR  -> This is signed
  flags:CHAR
  gelhead:PTR TO vs
  geltail:PTR TO vs
  nextline:PTR TO INT
-> This is actually PTR TO PTR TO INT
  lastcolor:PTR TO LONG
  collhandler:PTR TO colltable
  leftmost:INT
  rightmost:INT
  topmost:INT
  bottommost:INT
  firstblissobj:LONG
  lastblissobj:LONG
ENDOBJECT     /* SIZEOF=38 */

CONST RPF_FRST_DOT=1,
      RPF_ONE_DOT=2,
      RPF_DBUFFER=4,
      RPF_AREAOUTLINE=8,
      RPF_NOCROSSFILL=$20,
      RP_JAM1=0,
      RP_JAM2=1,
      RP_COMPLEMENT=2,
      RP_INVERSVID=4,
      RPF_TXSCALE=1

CONST RP_AREAPTRN=8,
      RP_MASK=24,
      RP_AOLPEN=27,
      RP_AREAPTSZ=29,
      RP_LINPATCNT=30,
      RP_FLAGS=32,
      RP_LINEPTRN=34

OBJECT rastport
  layer:PTR TO layer
  bitmap:PTR TO bitmap
  areaptrn:PTR TO INT  -> Target is unsigned
  tmpras:PTR TO tmpras
  areainfo:PTR TO areainfo
  gelsinfo:PTR TO gelsinfo
  mask:CHAR
  fgpen:CHAR  -> This is signed
  bgpen:CHAR  -> This is signed
  aolpen:CHAR  -> This is signed
  drawmode:CHAR  -> This is signed
  areaptsz:CHAR  -> This is signed
  linpatcnt:CHAR  -> This is signed
  dummy:CHAR
  flags:INT  -> This is unsigned
  lineptrn:INT  -> This is unsigned
  cp_x:INT
  cp_y:INT
  minterms[8]:ARRAY
  penwidth:INT
  penheight:INT
  font:PTR TO textfont
  algostyle:CHAR
  txflags:CHAR
  txheight:INT  -> This is unsigned
  txwidth:INT  -> This is unsigned
  txbaseline:INT  -> This is unsigned
  txspacing:INT
  rp_user:PTR TO LONG
  longreserved[2]:ARRAY OF LONG
  wordreserved[7]:ARRAY OF INT  -> Array is unsigned
  reserved[8]:ARRAY
ENDOBJECT     /* SIZEOF=100 */

OBJECT areainfo
  vctrtbl:PTR TO INT
  vctrptr:PTR TO INT
  flagtbl:PTR TO CHAR  -> Target is signed
  flagptr:PTR TO CHAR  -> Target is signed
  count:INT
  maxcount:INT
  firstx:INT
  firsty:INT
ENDOBJECT     /* SIZEOF=24 */

CONST ONE_DOTN=1,
      ONE_DOT=2,
      FRST_DOTN=0,
      FRST_DOT=1


OBJECT region
  bounds:rectangle
  regionrectangle:PTR TO regionrectangle
ENDOBJECT     /* SIZEOF=12 */

OBJECT regionrectangle
  next:PTR TO regionrectangle
  prev:PTR TO regionrectangle
  bounds:rectangle
ENDOBJECT     /* SIZEOF=16 */


CONST RPTAG_FONT=$80000000,
      RPTAG_APEN=$80000002,
      RPTAG_BPEN=$80000003,
      RPTAG_DRMD=$80000004,
      RPTAG_OUTLINEPEN=$80000005,
      RPTAG_WRITEMASK=$80000006,
      RPTAG_MAXPEN=$80000007,
      RPTAG_DRAWBOUNDS=$80000008


OBJECT bitscaleargs
  srcx:INT  -> This is unsigned
  srcy:INT  -> This is unsigned
  srcwidth:INT  -> This is unsigned
  srcheight:INT  -> This is unsigned
  xsrcfactor:INT  -> This is unsigned
  ysrcfactor:INT  -> This is unsigned
  destx:INT  -> This is unsigned
  desty:INT  -> This is unsigned
  destwidth:INT  -> This is unsigned
  destheight:INT  -> This is unsigned
  xdestfactor:INT  -> This is unsigned
  ydestfactor:INT  -> This is unsigned
  srcbitmap:PTR TO bitmap
  destbitmap:PTR TO bitmap
  flags:LONG
  xdda:INT  -> This is unsigned
  ydda:INT  -> This is unsigned
  reserved1:LONG
  reserved2:LONG
ENDOBJECT     /* SIZEOF=48 */


OBJECT simplesprite
  posctldata:PTR TO INT  -> Target is unsigned
  height:INT  -> This is unsigned
  x:INT  -> This is unsigned
  y:INT  -> This is unsigned
  num:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=12 */

OBJECT extsprite
  simplesprite:simplesprite
  wordwidth:INT  -> This is unsigned
  flags:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=16 */

CONST SPRITEA_WIDTH=$81000000,
      SPRITEA_XREPLICATION=$81000002,
      SPRITEA_YREPLICATION=$81000004,
      SPRITEA_OUTPUTHEIGHT=$81000006,
      SPRITEA_ATTACHED=$81000008,
      SPRITEA_OLDDATAFORMAT=$8100000A,
      GSTAG_SPRITE_NUM=$82000020,
      GSTAG_ATTACHED=$82000022,
      GSTAG_SOFTSPRITE=$82000024,
      GSTAG_SCANDOUBLED=$83000000


CONST FS_NORMAL=0,
      FSB_UNDERLINED=0,
      FSF_UNDERLINED=1,
      FSB_BOLD=1,
      FSF_BOLD=2,
      FSB_ITALIC=2,
      FSF_ITALIC=4,
      FSB_EXTENDED=3,
      FSF_EXTENDED=8,
      FSB_COLORFONT=6,
      FSF_COLORFONT=$40,
      FSB_TAGGED=7,
      FSF_TAGGED=$80,
      FPB_ROMFONT=0,
      FPF_ROMFONT=1,
      FPB_DISKFONT=1,
      FPF_DISKFONT=2,
      FPB_REVPATH=2,
      FPF_REVPATH=4,
      FPB_TALLDOT=3,
      FPF_TALLDOT=8,
      FPB_WIDEDOT=4,
      FPF_WIDEDOT=16,
      FPB_PROPORTIONAL=5,
      FPF_PROPORTIONAL=$20,
      FPB_DESIGNED=6,
      FPF_DESIGNED=$40,
      FPB_REMOVED=7,
      FPF_REMOVED=$80

OBJECT textattr
  name:LONG
  ysize:INT  -> This is unsigned
  style:CHAR
  flags:CHAR
ENDOBJECT     /* SIZEOF=8 */

OBJECT ttextattr
  name:LONG
  ysize:INT  -> This is unsigned
  style:CHAR
  flags:CHAR
  tags:PTR TO tagitem
ENDOBJECT     /* SIZEOF=12 */

CONST TA_DEVICEDPI=$80000001,
      MAXFONTMATCHWEIGHT=$7FFF

OBJECT textfont
  mn:mn
  ysize:INT  -> This is unsigned
  style:CHAR
  flags:CHAR
  xsize:INT  -> This is unsigned
  baseline:INT  -> This is unsigned
  boldsmear:INT  -> This is unsigned
  accessors:INT  -> This is unsigned
  lochar:CHAR
  hichar:CHAR
  chardata:PTR TO CHAR
  modulo:INT  -> This is unsigned
  charloc:PTR TO INT
  charspace:PTR TO INT
  charkern:PTR TO INT
ENDOBJECT     /* SIZEOF=52 */

CONST TE0B_NOREMFONT=0,
      TE0F_NOREMFONT=1

OBJECT textfontextension
  matchword:INT  -> This is unsigned
  flags0:CHAR
  flags1:CHAR
  backptr:PTR TO textfont
  origreplyport:PTR TO mp
  tags:PTR TO tagitem
  ofontpatchs:PTR TO INT  -> Target is unsigned
  ofontpatchk:PTR TO INT  -> Target is unsigned
ENDOBJECT     /* SIZEOF=24 */

CONST CT_COLORFONT=1,
      CT_GREYFONT=2,
      CT_ANTIALIAS=4,
      CTB_MAPCOLOR=0,
      CTF_MAPCOLOR=1,
      CT_COLORMASK=$f

OBJECT colorfontcolors
  reserved:INT
  count:INT  -> This is unsigned
  colortable:PTR TO INT  -> Target is unsigned
ENDOBJECT     /* SIZEOF=8 */

OBJECT colortextfont
  textfont:textfont
  flags:INT  -> This is unsigned
  depth:CHAR
  fgcolor:CHAR
  low:CHAR
  high:CHAR
  planepick:CHAR
  planeonoff:CHAR
  colorfontcolors:PTR TO colorfontcolors
  chardata[8]:ARRAY OF LONG
ENDOBJECT     /* SIZEOF=96 */

OBJECT textextent
  width:INT  -> This is unsigned
  height:INT  -> This is unsigned
  extent:rectangle
ENDOBJECT     /* SIZEOF=12 */


CONST VTAG_END_CM=0,
      VTAG_CHROMAKEY_CLR=$80000000,
      VTAG_CHROMAKEY_SET=$80000001,
      VTAG_BITPLANEKEY_CLR=$80000002,
      VTAG_BITPLANEKEY_SET=$80000003,
      VTAG_BORDERBLANK_CLR=$80000004,
      VTAG_BORDERBLANK_SET=$80000005,
      VTAG_BORDERNOTRANS_CLR=$80000006,
      VTAG_BORDERNOTRANS_SET=$80000007,
      VTAG_CHROMA_PEN_CLR=$80000008,
      VTAG_CHROMA_PEN_SET=$80000009,
      VTAG_CHROMA_PLANE_SET=$8000000A,
      VTAG_ATTACH_CM_SET=$8000000B,
      VTAG_NEXTBUF_CM=$8000000C,
      VTAG_BATCH_CM_CLR=$8000000D,
      VTAG_BATCH_CM_SET=$8000000E,
      VTAG_NORMAL_DISP_GET=$8000000F,
      VTAG_NORMAL_DISP_SET=$80000010,
      VTAG_COERCE_DISP_GET=$80000011,
      VTAG_COERCE_DISP_SET=$80000012,
      VTAG_VIEWPORTEXTRA_GET=$80000013,
      VTAG_VIEWPORTEXTRA_SET=$80000014,
      VTAG_CHROMAKEY_GET=$80000015,
      VTAG_BITPLANEKEY_GET=$80000016,
      VTAG_BORDERBLANK_GET=$80000017,
      VTAG_BORDERNOTRANS_GET=$80000018,
      VTAG_CHROMA_PEN_GET=$80000019,
      VTAG_CHROMA_PLANE_GET=$8000001A,
      VTAG_ATTACH_CM_GET=$8000001B,
      VTAG_BATCH_CM_GET=$8000001C,
      VTAG_BATCH_ITEMS_GET=$8000001D,
      VTAG_BATCH_ITEMS_SET=$8000001E,
      VTAG_BATCH_ITEMS_ADD=$8000001F,
      VTAG_VPMODEID_GET=$80000020,
      VTAG_VPMODEID_SET=$80000021,
      VTAG_VPMODEID_CLR=$80000022,
      VTAG_USERCLIP_GET=$80000023,
      VTAG_USERCLIP_SET=$80000024,
      VTAG_USERCLIP_CLR=$80000025,
      VTAG_PF1_BASE_GET=$80000026,
      VTAG_PF2_BASE_GET=$80000027,
      VTAG_SPEVEN_BASE_GET=$80000028,
      VTAG_SPODD_BASE_GET=$80000029,
      VTAG_PF1_BASE_SET=$8000002A,
      VTAG_PF2_BASE_SET=$8000002B,
      VTAG_SPEVEN_BASE_SET=$8000002C,
      VTAG_SPODD_BASE_SET=$8000002D,
      VTAG_BORDERSPRITE_GET=$8000002E,
      VTAG_BORDERSPRITE_SET=$8000002F,
      VTAG_BORDERSPRITE_CLR=$80000030,
      VTAG_SPRITERESN_SET=$80000031,
      VTAG_SPRITERESN_GET=$80000032,
      VTAG_PF1_TO_SPRITEPRI_SET=$80000033,
      VTAG_PF1_TO_SPRITEPRI_GET=$80000034,
      VTAG_PF2_TO_SPRITEPRI_SET=$80000035,
      VTAG_PF2_TO_SPRITEPRI_GET=$80000036,
      VTAG_IMMEDIATE=$80000037,
      VTAG_FULLPALETTE_SET=$80000038,
      VTAG_FULLPALETTE_GET=$80000039,
      VTAG_FULLPALETTE_CLR=$8000003A,
      VTAG_DEFSPRITERESN_SET=$8000003B,
      VTAG_DEFSPRITERESN_GET=$8000003C,
      VC_INTERMEDIATECLUPDATE=$80000080,
      VC_INTERMEDIATECLUPDATE_QUERY=$80000081,
      VC_NOCOLORPALETTELOAD=$80000082,
      VC_NOCOLORPALETTELOAD_QUERY=$80000083,
      VC_DUALPF_DISABLE=$80000084,
      VC_DUALPF_DISABLE_QUERY=$80000085

CONST GENLOCK_VIDEO=2,
      V_LACE=4,
      V_DOUBLESCAN=8,
      V_SUPERHIRES=$20,
      V_PFBA=$40,
      V_EXTRA_HALFBRITE=$80,
      GENLOCK_AUDIO=$100,
      V_DUALPF=$400,
      V_HAM=$800,
      V_EXTENDED_MODE=$1000,
      V_VP_HIDE=$2000,
      V_SPRITES=$4000,
      V_HIRES=$8000,
      EXTEND_VSTRUCT=$1000,
      VPF_A2024=$40,
      VPF_TENHZ=16,
      VPB_A2024=6,
      VPB_TENHZ=4

OBJECT colormap
  flags:CHAR
  type:CHAR
  count:INT  -> This is unsigned
  colortable:LONG
  vpe:PTR TO viewportextra
  lowcolorbits:LONG
  transparencyplane:CHAR
  spriteresolution:CHAR
  spriteresdefault:CHAR
  auxflags:CHAR
  vp:PTR TO viewport
  normaldisplayinfo:LONG
  coercedisplayinfo:LONG
  batch_items:PTR TO tagitem
  vpmodeid:LONG
  palextra:PTR TO paletteextra
  spritebase_even:INT  -> This is unsigned
  spritebase_odd:INT  -> This is unsigned
  bp_0_base:INT  -> This is unsigned
  bp_1_base:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=52 */

CONST CM_TRANSPARENYPLANE=16,
      COLORMAP_TYPE_V1_2=0,
      COLORMAP_TYPE_V1_4=1,
      COLORMAP_TYPE_V36=1,
      COLORMAP_TYPE_V39=2,
      COLORMAP_TRANSPARENCY=1,
      COLORPLANE_TRANSPARENCY=2,
      BORDER_BLANKING=4,
      BORDER_NOTRANSPARENCY=8,
      VIDEOCONTROL_BATCH=16,
      USER_COPPER_CLIP=$20,
      BORDER_SPRITES=$40,
      CMF_CMTRANS=1,
      CMF_CPTRANS=2,
      CMF_BRDRBLNK=4,
      CMF_BRDNTRAN=8,
      CMF_BRDRSPRT=$40,
      CMB_CMTRANS=0,
      CMB_CPTRANS=1,
      CMB_BRDRBLNK=2,
      CMB_BRDNTRAN=3,
      CMB_BRDRSPRT=6,
      SPRITERESN_ECS=0,
      SPRITERESN_140NS=1,
      SPRITERESN_70NS=2,
      SPRITERESN_35NS=3,
      SPRITERESN_DEFAULT=-1,
      CMAF_FULLPALETTE=1,
      CMAB_FULLPALETTE=0,
      CMAF_NO_INTERMED_UPDATE=2,
      CMAB_NO_INTERMED_UPDATE=1,
      CMAF_NO_COLOR_LOAD=4,
      CMAB_NO_COLOR_LOAD=2,
      CMAF_DUALPF_DISABLE=3,
      CMAB_DUALPF_DISABLE=8

OBJECT paletteextra
  semaphore:ss
  firstfree:INT  -> This is unsigned
  nfree:INT  -> This is unsigned
  firstshared:INT  -> This is unsigned
  nshared:INT  -> This is unsigned
  refcnt:LONG
  alloclist:LONG
  viewport:PTR TO viewport
  sharablecolors:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=68 */

CONST PRECISION_EXACT=-1,
      PRECISION_IMAGE=0,
      PRECISION_ICON=16,
      PRECISION_GUI=$20,
      OBP_PRECISION=$84000000,
      OBP_FAILIFBAD=$84000001,
      PEN_EXCLUSIVE=1,
      PEN_NO_SETCOLOR=2,
      PENF_EXCLUSIVE=1,
      PENF_NO_SETCOLOR=2,
      PENB_EXCLUSIVE=0,
      PENB_NO_SETCOLOR=1

OBJECT viewport
  next:PTR TO viewport
  colormap:PTR TO colormap
  dspins:PTR TO coplist
  sprins:PTR TO coplist
  clrins:PTR TO coplist
  ucopins:PTR TO ucoplist
  dwidth:INT
  dheight:INT
  dxoffset:INT
  dyoffset:INT
  modes:INT  -> This is unsigned
  spritepriorities:CHAR
  extendedmodes:CHAR
  rasinfo:PTR TO rasinfo
ENDOBJECT     /* SIZEOF=40 */

OBJECT view
  viewport:PTR TO viewport
  lofcprlist:PTR TO cprlist
  shfcprlist:PTR TO cprlist
  dyoffset:INT
  dxoffset:INT
  modes:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=18 */

OBJECT viewextra
  xln:xln
  view:PTR TO view
  monitor:PTR TO monitorspec
  topline:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=34 */

OBJECT viewportextra
  xln:xln
  viewport:PTR TO viewport
  displayclip:rectangle
  vectable:LONG
  driverdata[2]:ARRAY OF LONG
  flags:INT  -> This is unsigned
  origin[2]:ARRAY OF tpoint
  cop1ptr:LONG
  cop2ptr:LONG
ENDOBJECT     /* SIZEOF=58 */

CONST VPXB_FREE_ME=0,
      VPXF_FREE_ME=1,
      VPXB_VP_LAST=1,
      VPXF_VP_LAST=2,
      VPXB_STRADDLES_256=4,
      VPXF_STRADDLES_256=16,
      VPXB_STRADDLES_512=5,
      VPXF_STRADDLES_512=$20

OBJECT rasinfo
  next:PTR TO rasinfo
  bitmap:PTR TO bitmap
  rxoffset:INT
  ryoffset:INT
ENDOBJECT     /* SIZEOF=12 */

CONST MVP_OK=0,
      MVP_NO_MEM=1,
      MVP_NO_VPE=2,
      MVP_NO_DSPINS=3,
      MVP_NO_DISPLAY=4,
      MVP_OFF_BOTTOM=5,
      MCOP_OK=0,
      MCOP_NO_MEM=1,
      MCOP_NOP=2

OBJECT dbufinfo
  link1:LONG
  count1:LONG
  safemessage:mn
  userdata1:LONG
  link2:LONG
  count2:LONG
  dispmessage:mn
  userdata2:LONG
  matchlong:LONG
  copptr1:LONG
  copptr2:LONG
  copptr3:LONG
  beampos1:INT  -> This is unsigned
  beampos2:INT  -> This is unsigned
ENDOBJECT     /* SIZEOF=84 */

